/*
 Crivello di Eratostene
*/
#include <stdio.h>

int main()
{
  int crivello[10][10];
  int i,j;

  /* inizializza la tabella */
  for (i=0; i<10; i++)
    for (j=0; j<10; j++)
      crivello[i][j] = (10*i)+(j+1);

  /* cancella il numero 1 */
  crivello[0][0] = 0;

  /* esegue l'algoritmo per il calcolo dei numeri primi */
  for (i=2; i<=100; i++)
  {
    if (crivello[(i-1)/10][(i-1)%10]!=0)
    {
      for (j=2*i; j<=100; j=j+i)
      {
        crivello[(j-1)/10][(j-1)%10]=0;
      }
    }
  }

  /* stampa la matrice in forma tabellare */
  for (i=0; i<10; i++)
  {
    for (j=0; j<10; j++)
      printf(" %3d ",crivello[i][j]);
    printf("\n");
  }
}
